//Icebow.cs
//Icebow and Icebow weapon stuff

datablock AudioProfile(IcebowHitSound)
{
   filename    = "./ArbalestHit.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(IcebowFireSound)
{
   filename    = "./ArbalestFire.wav";
   description = AudioClosest3d;
   preload = true;
};


datablock PlayerData(IcebowArmor : PlayerStandardArmor)
{

   runForce = 10 * 180;
   runEnergyDrain = 0;
   minRunEnergy = 0;
   maxForwardSpeed = 0;
   maxBackwardSpeed = 0;
   maxSideSpeed = 0;

   maxForwardCrouchSpeed = 0;
   maxBackwardCrouchSpeed = 0;
   maxSideCrouchSpeed = 0;

   jumpForce = 0 * 0; //0 * 0;
   jumpEnergyDrain = 0;
   minJumpEnergy = 0;
   jumpDelay = 0;

	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;


	uiName = "";
	showEnergyBar = false;

   runSurfaceAngle  = 45;
   jumpSurfaceAngle = 45;
};


//Icebow trail
datablock ParticleData(IcebowSmokeParticle)
{
   dragCoefficient      = 3;
   gravityCoefficient   = 0.2;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 1400;
   lifetimeVarianceMS   = 400;
   textureName          = "base/data/particles/cloud";
   spinSpeed		= 10.0;
   spinRandomMin		= -50.0;
   spinRandomMax		= 50.0;
   colors[0]     = "0 0 1 0.5";
   colors[1]     = "0 0 1 1";
   colors[2]     = "0.1 0.1 0.1 0.9";
   colors[3]     = "0.0 0.0 1.0 1.0";

   sizes[0]      = 0.5;
   sizes[1]      = 0.2;
   sizes[2]      = 0.2;
   sizes[3]      = 0.5;

   times[0] = 0.0;
   times[1] = 0.3;
   times[2] = 0.6;
   times[3] = 1.0;

   useInvAlpha = false;
};
datablock ParticleEmitterData(IcebowSmokeEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 15;
   velocityVariance = 1.0;
   ejectionOffset   = 3.0;
   thetaMin         = 0;
   thetaMax         = 40;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "IcebowSmokeParticle";
};


datablock ParticleData(IcebowBubbleParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 525;
	lifetimeVarianceMS   = 15;
	textureName          = "base/data/particles/bubble";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.9 0.9 0.0 0.9";
	colors[1]     = "0.9 0.5 0.0 0.0";
	sizes[0]      = 0.3;
	sizes[1]      = 0.6;

	useInvAlpha = false;
};
datablock ParticleEmitterData(IcebowBubbleEmitter)
{
   ejectionPeriodMS = 30;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "IcebowBubbleParticle";

   uiName = "Icebow Bubble";
};
datablock ParticleData(IcebowTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 200;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= false;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/cloud";
	//animTexName		= "~/data/particles/cloud";

	// Interpolation variables
	colors[0]	= "0 0 1 0.2";
	colors[1]	= "0 0 1 0.0";
	sizes[0]	= 0.4;
	sizes[1]	= 0.02;
	times[0]	= 0.0;
	times[1]	= 1.0;
};

datablock ParticleEmitterData(IcebowTrailEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = IcebowTrailParticle;

   useEmitterColors = true;
   uiName = "Icebow Trail";
};

//effects
datablock ParticleData(IcebowStickExplosionParticle)
{
	dragCoefficient      = 5;
	gravityCoefficient   = 0.1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 300;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0 0.2 1 0.9";
	colors[1]     = "0 0.4 1 0.0";
	sizes[0]      = 0.75;
	sizes[1]      = 0.0;
};
datablock ParticleEmitterData(IcebowStickExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 80;
   thetaMax         = 80;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "IcebowStickExplosionParticle";

   useEmitterColors = true;
   uiName = "Icebow Stick";
};

datablock ParticleData(IcebowExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.3;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 300;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.0 0.4 1 0.9";
	colors[1]     = "0.0 0.2 1 0.0";
	sizes[0]      = 2.45;
	sizes[1]      = 1.0;

   useInvAlpha = true;
   playerBurnTime = 3000;
};

datablock ParticleEmitterData(IcebowExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 3;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "IcebowExplosionParticle";

   useEmitterColors = true;
   uiName = "Icebow Vanish";
};

datablock ExplosionData(IcebowStickExplosion)
{
   //explosionShape = "";
	soundProfile = IcebowHitSound;

   lifeTimeMS = 150;

   particleEmitter = IcebowStickExplosionEmitter;
   particleDensity = 40;
   particleRadius = 0.2;

   emitter[0] = IcebowStickExplosionEmitter;
   emitter[1] = IcebowSmokeEmitter;
   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 1;
   lightStartColor = "1 0.6 0";
   lightEndColor = "0 0 0";
};

datablock ExplosionData(IcebowExplosion)
{
   //explosionShape = "";
	soundProfile = "";

   lifeTimeMS = 50;

   emitter[0] = IcebowExplosionEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 1;
   lightStartColor = "1 0.5 0";
   lightEndColor = "0 0 0";

   playerBurnTime = 3000;
};


//projectile
AddDamageType("IcebowDirect",   '<bitmap:add-ons/Heed_Medieval/CI_Icebow> %1',    '%2 <bitmap:add-ons/Heed_Medieval/CI_Icebow> %1',0.5,1);

datablock ProjectileData(IcebowProjectile)
{
   projectileShapeName = "./Flamearrow.dts";

   directDamage        = 25;
   directDamageType    = $DamageType::IcebowDirect;

   radiusDamage        = 0;
   damageRadius        = 0;
   radiusDamageType    = $DamageType::IcebowDirect;

   explosion             = IcebowExplosion;
   stickExplosion        = IcebowStickExplosion;
   bloodExplosion        = IcebowStickExplosion;
   particleEmitter       = IcebowTrailEmitter;
   explodeOnPlayerImpact = true;
   explodeOnDeath        = true;  

   armingDelay         = 4000;
   lifetime            = 4000;
   fadeDelay           = 4000;

   isBallistic         = true;
   bounceAngle         = 170; //stick almost all the time
   minStickVelocity    = 10;
   bounceElasticity    = 0.2;
   bounceFriction      = 0.01;   
   gravityMod = 0.25;

   hasLight    = true;
   lightRadius = 3.0;
   lightColor  = "0 0.4 1";

   muzzleVelocity      = 80;
   velInheritFactor    = 1;

   uiName = "Icebow";
};


//////////
// item //
//////////
datablock ItemData(IcebowItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Icebow.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Icebow";
	iconName = "./icon_Icebow";
	doColorShift = true;
	colorShiftColor = "0.400 0.196 0 1.000";

	 // Dynamic properties defined by the scripts
	image = IcebowImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(IcebowImage)
{
   // Basic Item properties
   shapeFile = "./Icebow.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 10" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = IcebowItem;
   ammo = " ";
   projectile = IcebowProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = IcebowItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Reload";
	stateTimeoutValue[2]            = 0.05;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateSound[2]					= IcebowFireSound;

	stateName[3]			= "Reload";
	stateSequence[3]                = "Reload";
	stateAllowImageChange[3]        = false;
	stateTimeoutValue[3]            = 1.3;
	stateWaitForTimeout[3]		= true;
	stateTransitionOnTimeout[3]     = "Check";

	stateName[4]			= "Check";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "Fire";

	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.2;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]		= true;
	//stateSequence[5]                = "Reload";
	stateScript[5]                  = "onStopFire";


};

package iceBow
{
function Icebowprojectile::damage(%this,%obj,%col,%fade,%pos,%normal)
	{
   parent::damage(%this,%obj,%col,%fade,%pos,%normal);

if(%col.getType() & $Typemasks::VehicleObjectType)
{
   return;
}

   %col.lastDatablock = %col.getDatablock();  
   %col.setDatablock(Icebowarmor);
   %col.schedule(5000,setDatablock,%col.lastDatablock);
   %col.setTempColor("0.66 0.75 1 1",5000);      
	}
};
activatePackage(iceBow);




